# Псевдонеслучайность
Мы перехватили трафик в очередном "ориентированном на конфиденциальность" чате, может получится найти что-нибудь интересное? 

# Генерация трафика
На VM1 (192.168.43.115) запускаем server.exe

![image](Pasted image 20220831011820.png)

Запускаем client.exe и вводим аутентификационные данные JohnDoe:1234:

![image](Pasted image 20220831011906.png)

"База данных" с паролями хранится в файле passwords.db:

![image](Pasted image 20220831012003.png)

На VM2 (192.168.43.183) запускаем wireshark, далее запускаем client.exe, на VM1 в окне server.exe проверяем подключение

Подключаемся под именем LarryLoe:1234

Создаем активность:

VM2: Hello!
VM1: Hi
VM2: I just wanna say
VM1: ???
VM2: I have your flag {MCTF_SomeLongFlaaaaaaaaaaaaaaaaaaaaag}

# Решение
Открываем в IDA Pro клиент или сервер

На вкладке strings (Shift + F12) видим строки:

![image](Pasted image 20220829232847.png)

DH и Exchange намекают на использование схемы обмена ключами Диффи-Хеллмана. Изучим данную реализацию, в частности, генерацию случайных данных, ведь название задачи - "Псевдонеслучайность". 

### Public key
Изучим блок между сообщениями "Generate random data" и "Success":

![image](Pasted image 20220829233216.png)

Видно, что используется результат функции time(0) в качестве seed'а для функции srand, которая инициализирует генератор псевдослучайных чисел. Далее буфер с публичным ключом заполняется данной информацией.

Далее идут непосредственно функции, связанные с арифметикой в поле, вместо их разбора достаточно почитать описание на википедии.

После генерации публичного ключа (32 байта), он отправляется с помощью send():

![image](Pasted image 20220829235240.png)

Выше в этой схеме можно заметить, что также в схеме участвуют:
 
Простой модуль P:

![image](Pasted image 20220830003508.png)

Простое число g:

![image](Pasted image 20220830003836.png)

В клиенте используется аналогичный код для генерации публичного ключа, таким образом имеем, что большое случайное число a в схеме Диффи-Хеллмана (g^a (mod p)) генерируются с помощью функции rand, т.е. вполне детерминированно. Значит генерация секрета зависит полностью от time(0) - текущего времени. Время генерации публичных ключей в схеме обмена можно получить из pcap файла.

### Shared key и шифрование
После обмена публичными ключами генерируется SK и запоминается в некой структуре по смещению 0x38:

![image](Pasted image 20220830005329.png)

Далее, после выхода из данной функции, происходит переход в цикл обработки сообщений от клиента:

![image](Pasted image 20220830005911.png)

В функции ClientRecv видно, что данные накрываются шифрованием с использованием ключа (смещение 7 * 8 = 56 = 0x38, которое встречалось ранее)

![image](Pasted image 20220830010134.png)

### Трафик
Таким образом, осталось только расшифровать данные. Самый простой способ - запустить программу в отладчике и подставить время (в результат time(0)), соответствующее обмену ключами в pcap-файле. Далее сгенерированный программой SK можно использовать для расшифрования всей переписки. 

Нужные PK можно найти в Wireshark'е по следующему фильтру (в коде выше явно видно, что в send отправляется 32 байта):

![image](Pasted image 20220831013553.png)
